$offlisting

* By Adam Blake

* This file is included in Store.gms
* You should not include this file directly

* This file stores values when Storename IS a set name


$if not setglobal Modelname $goto startloop2
* Information about the model:
Status("Equations",%Storename%) = %Modelname%.numequ;
Status("Variables",%Storename%) = %Modelname%.numvar;
Status("Nonzeros",%Storename%) = %Modelname%.numnz;

* Information about the last solve:
Status("ModelStat",%Storename%) = %Modelname%.modelstat;
Status("SolveStat",%Storename%) = %Modelname%.solvestat;
Status("Workspace",%Storename%) = %Modelname%.workspace;
Status("Violations",%Storename%) = %Modelname%.domusd;
Status("Infeasible",%Storename%) = %Modelname%.numinfes;
Status("Nonoptimal",%Storename%) = %Modelname%.numnopt;
Status("Redefined",%Storename%) = %Modelname%.numredef;
Status("Iterations",%Storename%) = %Modelname%.iterusd;
Status("Seconds",%Storename%) = %Modelname%.resusd;
Status("Objective",%Storename%) = %Modelname%.objval;



*===============
$label startloop2
*===============
$if setglobal sv_base simbase(%Storename%,"%sv_base%") = yes;
$if not setglobal sv_base simbase(%Storename%,"NotBased") = yes;


$set VarName %1
$if vartype %1 $set VarName %1.L
$if dimension 0 %1 $goto Zero2
$if not declared v_%1 Parameter v_%1;
$if not declared p_%1 Parameter p_%1;
$if not declared c_%1 Parameter c_%1;

$label checkdims2
$if dimension 3 %1 $goto Three2
$if dimension 2 %1 $goto Two2
$if dimension 1 %1 $goto One2

$label Zero2
Results("%1",%Storename%) = %VarName%;
$if not setglobal sv_base $goto endloop2
ResultsCh("%1",%Storename%) = %VarName% - Results("%1","%sv_base%");
ResultsPer("%1",%Storename%)$Results("%1","%sv_base%") = 100*[%VarName% - Results("%1","%sv_base%")]/Results("%1","%sv_base%");
$goto endloop2

$label One2
v_%1(SV__1,%Storename%) = %VarName%(SV__1);
$if not setglobal sv_base $goto endloop2
c_%1(SV__1,%Storename%) = %VarName%(SV__1) - v_%1(SV__1,"%sv_base%");
p_%1(SV__1,%Storename%)$v_%1(SV__1,"%sv_base%") 
	= 100*[%VarName%(SV__1) - v_%1(SV__1,"%sv_base%")] /v_%1(SV__1,"%sv_base%") ;
$goto endloop2

$label Two2
v_%1(%Storename%,SV__1,SV__2) = %VarName%(SV__1,SV__2);
option v_%1:3:1:1;
$if not setglobal sv_base $goto endloop2
c_%1(%Storename%,SV__1,SV__2) = %VarName%(SV__1,SV__2) - v_%1("%sv_base%",SV__1,SV__2);
option c_%1:3:1:1;
p_%1(%Storename%,SV__1,SV__2)$v_%1("%sv_base%",SV__1,SV__2) 
	= 100*[%VarName%(SV__1,SV__2) - v_%1("%sv_base%",SV__1,SV__2)] 
	/v_%1("%sv_base%",SV__1,SV__2) ;
option p_%1:3:1:1;

$goto endloop2

$label Three2
v_%1(%Storename%,SV__1,SV__2,SV__3) = %VarName%(SV__1,SV__2,SV__3);
$if not setglobal sv_base $goto endloop2
c_%1(%Storename%,SV__1,SV__2,SV__3)) = %VarName%(SV__1,SV__2,SV__3)) 
				- v_%1("%sv_base%",SV__1,SV__2SV__3));
p_%1(%Storename%,SV__1,SV__2,SV__3))$v_%1("%sv_base%",SV__1,SV__2,SV__3)) 
	= 100*[%VarName%(SV__1,SV__2,SV__3)) - v_%1("%sv_base%",SV__1,SV__2,SV__3))] 
		/v_%1("%sv_base%",SV__1,SV__2,SV__3)) ;

$goto endloop2


$label endloop2
$shift
$if "%1"=="" $goto end2
$goto startloop2

$label end2
